{$mode delphi}

const MAXN = 200;

type coord = record
  i, j : integer;
end;

const di:array[1..4] of integer = (0, 1, 0, -1);
      dj:array[1..4] of integer = (1, 0, -1, 0);
      
var data : array[1..MAXN, 1..MAXN] of integer;
    was_searched : array[1 .. (MAXN*MAXN)div 3+1] of boolean;

    fin, fout : text;


function solve_curr_field : boolean;
var XSz, YSz : byte;
    i,j : byte;
    d : byte;
    k, MAX_K : integer;
    current_color : integer;
    qqq : array[1..8] of coord;
    q_head, q_after_tail : integer;
    curr, nabour : coord;
Begin
  readln(fin, YSz, XSz);
	MAX_K := (XSz*YSz)div 3;
	for k:=1 to MAX_K do
		was_searched[k] := false;

	for i:=1 to YSz do
  	for j:=1 to XSz do
      read(fin, data[i][j]);
	for i:=1 to YSz do
  	for j:=1 to XSz do
			if data[i][j] > 0 then begin
				current_color := data[i][j];
				if was_searched[current_color] then begin
          solve_curr_field := false; exit
        end;
				was_searched[current_color] := true;
				data[i][j] := -data[i][j];
				qqq[1].i := i; qqq[1].j := j;
				q_after_tail := 2; q_head := 1;
				while (q_head < q_after_tail) and (q_after_tail <= 3 + 1) do begin// where 3 is triomino size, can be changed
					curr := qqq[q_head]; inc(q_head);
					for d := 1 to 4 do begin
						nabour.i := curr.i + di[d];
						nabour.j := curr.j + dj[d];
						if (nabour.i > 0) and (nabour.i <= YSz) and (nabour.j > 0) and (nabour.j <= XSz) and (data[nabour.i][nabour.j] = current_color) then begin
							qqq[q_after_tail] := nabour;
              inc(q_after_tail);
							data[nabour.i][nabour.j] := -data[nabour.i][nabour.j];
						end
					end
				end;
				if q_after_tail<>3 + 1 then  begin
          solve_curr_field := false; exit
        end;
			end;
	for k:=1 to MAX_K do
		if not was_searched[k] then begin
      solve_curr_field := false; exit
    end;
	solve_curr_field := true;
End;

var the_test, TEST_NUM : byte;

BEGIN
	assign(fin, 'triomino.dat');  reset(fin);
	assign(fout, 'triomino.sol'); rewrite(fout);
  readln(fin, TEST_NUM);
	for the_test := 1 to TEST_NUM do
		if(solve_curr_field()) then
			writeln(fout, 'YES')
		else
			writeln(fout, 'NO');
	close(fout);
	close(fin);
END.
